{$A+,B-,D+,E+,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
unit hex_fl;

interface
procedure run;
implementation

uses Graph,video13h,keyboard,common;

 const
  pntsnr=     12;
  facenr=     20;

 Verts: array [1..(pntsnr*3)] of integer=
           (200, 0, -120,
            62, -189, -120,
            -160, -119, -120,
            -163, 115, -120,
            58, 191, -120,
            0, 0, -243,
            -200, -3, 79,
            -62, -189, 80,
            -65, 188,  80,
            160, -115, 79,
            160, 118, 78,
            -1, 0, 202);

 {Format: nr of faces; face1,face2,face3...; color;texmap info}
 { This format is compatible with 3ded}
 connect: array [0..facenr*3-1] of integer=
          (
           6, 7, 11,
           4, 3, 8,
           6, 2, 7,
           2, 1, 7,
           7, 1, 9,
           7, 9, 11,
           11, 9, 10,
           9, 0,  10,
           9, 1,  0,
           5, 0, 1,
           5, 1, 2,
           6, 3, 2,
           5, 2, 3,
           4, 0, 5,
           5, 3, 4,
           10, 0, 4,
           8, 6, 11,
           10, 8, 11,
           10, 4, 8,
           8, 3,  6 );

 type
  VecVerts = record
          x : real;
          y : real;
          z : real;
 end;

 screen_coords = record
  x : word;
  y : word;
 end;

 { All the vairables declared }

 var
  scrcoords : array[1..pntsnr] of screen_coords;
  polyxyz,polyxyzb : array[1..pntsnr] of vecverts;
  normxyz,normxyzb : array[1..facenr] of vecverts;
  rotxyz : array [1..pntsnr] of vecverts;
  rotnxyz : array [1..facenr] of vecverts;
  xr,yr,zr : integer;

  v,dist,i,offs : LongInt;
  VecCol : longint;
  xadd,yadd,zadd : real;
  poly : array [0..199,1..2] of LongInt;

  Page:   Boolean;
  Ch:     Char;

procedure filltriangle(x1,y1,x2,y2,x3,y3:integer);
var T: array[1..3] of PointType;
begin
t[1].x:=x1;t[1].y:=y1;
t[2].x:=x2;t[2].y:=y2;
t[3].x:=x3;t[3].y:=y3;
FillPoly(3,T);
end;


procedure ChangePage;
begin
if Page then
   begin
   SetActivePage(0);
   {vrwait;}
   SetVisualPage(1{,false});
   Page:=false;
   end
else
   begin
   SetActivePage(1);
{  vrwait;}
   SetVisualPage(0{,false});
   Page:=true;
   end;
cleardevice;
{SetFillColor(clBlack);
Bar(86,98,546,302);}
end;

 { This routine defines the vertices of the cube }
 { They must be in this order for calculating normals }
procedure SetuPoints;
begin
i:=1;
v:=1;
repeat
  polyxyzb[v].x:=Verts[i];i:=i+1;
  polyxyzb[v].y:=Verts[i];i:=i+1;
  polyxyzb[v].z:=Verts[i];i:=i+1;
  v:=v+1;
until v=pntsnr+1;
for i:=0 to facenr*3-1 do connect[i]:=connect[i]+1
end;

procedure SetUpsc; { This creates the lookup table }
var loop1:integer;
    ax,ay,az,bx,by,bz : real;
begin
offs:=0 ;
for loop1:=0 to 360 do
    begin
    precsin[loop1]:=sin(loop1*pi/180);
    preccos[loop1]:=cos(loop1*pi/180);
    end;
offs:=0 ;
for i:=1 to facenr do
    begin
    { Here I precalculate the normals and then all
    I have to do is rotate them for each frame }
    ax:=(polyxyzb[connect[1+offs]].x)-(polyxyzb[connect[offs]].x);
    ay:=(polyxyzb[connect[1+offs]].y)-(polyxyzb[connect[offs]].y);
    az:=(polyxyzb[connect[1+offs]].z)-(polyxyzb[connect[offs]].z);
    bx:=(polyxyzb[connect[2+offs]].x)-(polyxyzb[connect[offs]].x);
    by:=(polyxyzb[connect[2+offs]].y)-(polyxyzb[connect[offs]].y);
    bz:=(polyxyzb[connect[2+offs]].z)-(polyxyzb[connect[offs]].z);
    normxyz[i].x:=0;normxyz[i].y:=0;normxyz[i].z:=0;
    normxyzb[i].x:=0;normxyzb[i].y:=0;normxyzb[i].z:=0;
    normxyzb[i].x:=(ay*bz)-(by*az);
    normxyzb[i].y:=(az*bx)-(bz*ax);
    normxyzb[i].z:=(ax*by)-(bx*ay);
    offs:=offs+3;
    end;
end;

procedure RotatePoints(xrot,yrot,zrot:integer);
var sinxr,cosxr,sinyr,cosyr,sinzr,coszr : real;
begin
 { here are all rotations values updated and precalculated }
 xr:=xr+xrot;if xr>360 then xr:=1;if xr<0 then xr:=360;
 yr:=yr+yrot;if yr>360 then yr:=1;if yr<0 then zr:=360;
 zr:=zr+zrot;if zr>360 then zr:=1;if zr<0 then zr:=360;
 sinxr:=precsin[xr];cosxr:=preccos[xr];
 sinyr:=precsin[yr];cosyr:=preccos[yr];
 sinzr:=precsin[zr];coszr:=preccos[zr];
 for i:=1 to pntsnr do
     begin
     { this is the formula for vector rotations around all axis in 3d space }
     rotxyz[i].x:=0;rotxyz[i].y:=0;rotxyz[i].z:=0;
     polyxyz[i].x:=0;polyxyz[i].y:=0;polyxyz[i].z:=0;
     polyxyz[i].x:=polyxyzb[i].x;
     polyxyz[i].y:=polyxyzb[i].y;
     polyxyz[i].z:=polyxyzb[i].z;
     rotxyz[i].y:=polyxyz[i].y*cosxr-polyxyz[i].z*sinxr;
     rotxyz[i].z:=polyxyz[i].z*cosxr+polyxyz[i].y*sinxr;
     polyxyz[i].y:=rotxyz[i].y;
     polyxyz[i].z:=rotxyz[i].z;
     rotxyz[i].z:=polyxyz[i].z*cosyr-polyxyz[i].x*sinyr;
     rotxyz[i].x:=polyxyz[i].x*cosyr+polyxyz[i].z*sinyr;
     polyxyz[i].x:=rotxyz[i].x;
     rotxyz[i].x:=polyxyz[i].x*coszr-polyxyz[i].y*sinzr;
     rotxyz[i].y:=polyxyz[i].y*coszr+polyxyz[i].x*sinzr;
     end;
 for i:=1 to facenr do
     begin
     rotnxyz[i].x:=0;rotnxyz[i].y:=0;rotnxyz[i].z:=0;
     normxyz[i].x:=normxyzb[i].x;
     normxyz[i].y:=normxyzb[i].y;
     normxyz[i].z:=normxyzb[i].z;
     rotnxyz[i].y:=normxyz[i].y*cosxr-normxyz[i].z*sinxr;
     rotnxyz[i].z:=normxyz[i].z*cosxr+normxyz[i].y*sinxr;
     normxyz[i].y:=rotnxyz[i].y;
     normxyz[i].z:=rotnxyz[i].z;
     rotnxyz[i].z:=normxyz[i].z*cosyr-normxyz[i].x*sinyr;
     rotnxyz[i].x:=normxyz[i].x*cosyr+normxyz[i].z*sinyr;
     normxyz[i].x:=rotnxyz[i].x;
     rotnxyz[i].x:=normxyz[i].x*coszr-normxyz[i].y*sinzr;
     rotnxyz[i].y:=normxyz[i].y*coszr+normxyz[i].x*sinzr;
     end;
end;

procedure ScrProject(xc,yc,zc:integer);
begin
for i:=1 to pntsnr do
    begin
    scrcoords[i].x:=trunc((320*(rotxyz[i].x+xc)/(dist-(rotxyz[i].z+zc)))+320);
    scrcoords[i].y:=trunc(200-(320*(rotxyz[i].y+yc)/(dist-(rotxyz[i].z+zc))));
    end;
end;

procedure Draw;
begin
offs:=0 ;
for i:=1 to facenr do
    begin
    VecCol:=trunc(rotnxyz[i].z/400);
    if rotnxyz[i].z>10000 then
       begin
       setcolor(vecCol);
       SetFillstyle(1,vecCol{i mod 15+1});
       filltriangle (scrcoords[connect[offs]].x,scrcoords[connect[offs]].y,
                     scrcoords[connect[1+offs]].x,scrcoords[connect[1+offs]].y,
                     scrcoords[connect[2+offs]].x,scrcoords[connect[2+offs]].y);
       end;
    offs:=offs+3;
    end;
end;

{-------FLY------}
const n=50;
      deep=10000;
      step=50;
      xmax2=320;
      ymax2=200;

var x,y,z:array [1..n] of real;
procedure initfly;
begin
for i:=1 to n do
   begin
   x[i]:=(random-0.5)*640;
   y[i]:=(random-0.5)*400;
   z[i]:=random*deep;
   end;
end;

function noborders:boolean;
begin
noborders:=(x[i]<-xmax2) or
           (x[i]> xmax2) or
           (y[i]<-ymax2) or
           (y[i]> ymax2) or
           (z[i]<=2);
end;

procedure range;
begin
for i:=1 to n do
 if noborders then
    begin
{    erase;}
    x[i]:=(random-0.5)*640;
    y[i]:=(random-0.5)*480;
    z[i]:=deep;
    end;
end;

procedure movefly;
begin
range;
for i:=1 to n do
    begin
    x[i]:=x[i]*z[i];
    y[i]:=y[i]*z[i];
    z[i]:=z[i]-step;
    x[i]:=x[i]/z[i];
    y[i]:=y[i]/z[i];
    putpixel(round(x[i])+xmax2,round(y[i])+ymax2,255);
    end;
end;

procedure svgadriver;external;{$L svga256}

var gd,gm:integer;
    mode:integer;
    tim:longint;
    a:word;
    x1,x2,x3,y1,y2,y3:integer;

procedure run;
label key;
begin
if _keypressed then exit;
gm:=1;
asm
   mov ax,0003h
   int 10h
end;
initgraph(gd,gm,'');

SetPal (255,63,63,63);
for i:=1 to 126 do SetPal (i,i div 5,i div 3,i div 3);

for tim:=0 to 255 do
    begin
    movefly;
    ChangePage;
    if _keypressed then goto key;
    SetPal(255,tim div 4,tim div 4,tim div 4);
    end;

Dist:=6000;
mode:=0;
tim:=0;
repeat
    rotatepoints (3,4,-2);
    scrproject(0,0,0);
    movefly;
    Draw;
    ChangePage;
    case mode of
         0:if dist>700 then dec(dist,30) else inc(mode);
         1:if tim<200 then inc(tim) else begin inc(mode);tim:=0;end;
         2:if tim<126 then
              begin
              inc(tim);
              for a:=tim to 126 do setpal(a,(a-tim) div 5,(a-tim) div 3,(a-tim) div 3)
              end else inc(mode);
         3:break;
         end;
    if _keypressed then goto key;
until false;

Dist:=6000;
mode:=-1;
tim:=0;
repeat
    rotatepoints (3,4,-2);
    scrproject(-400,0,0);
    movefly;
    Draw;
    scrproject(400,0,0);
    Draw;
    ChangePage;
    case mode of
        -1:begin for i:=1 to 126 do SetPal (i,i div 5,i div 3,i div 3);inc(mode);end;
         0:if dist>1500 then dec(dist,30) else inc(mode);
         1:if tim<200 then inc(tim) else begin inc(mode);tim:=0;end;
         2:if tim<126 then
              begin
              inc(tim);
              for a:=tim to 126 do setpal(a,(a-tim) div 5,(a-tim) div 3,(a-tim) div 3)
              end else inc(mode);
         3:break;
         end;
    if _keypressed then goto key;
until false;

Dist:=6000;
mode:=-1;
tim:=0;
x1:=-400;x2:=400;x3:=0;
y1:=-200;y2:=-200;y3:=200;
repeat
    rotatepoints (3,4,-2);
    scrproject(x1,y1,0);
    movefly;
    Draw;
    scrproject(x2,y2,0);
    Draw;
    scrproject(x3,y3,0);
    Draw;
    ChangePage;
    case mode of
        -1:begin for i:=1 to 126 do SetPal (i,i div 5,i div 3,i div 3);inc(mode);end;
         0:if dist>1800 then dec(dist,30) else inc(mode);
         1:if tim<200 then inc(tim) else begin inc(mode);tim:=0;end;
         2:if y3<1600 then begin inc(y3,10); dec(x1,10);dec(y1,10); inc(x2,10);dec(y2,10); end else inc(mode);
         3:break;
         end;
    if _keypressed then goto key;
until false;
for tim:=255 downto 0 do
    begin
    movefly;
    ChangePage;
    if _keypressed then goto key;
    SetPal(255,tim div 4,tim div 4,tim div 4);
    end;
key:
{closegraph;}
end;

begin
writeln('Initializing...');
initfly;
SetuPoints;
SetupSc;
gd:=installuserdriver('svga256',nil);
if registerbgidriver(@svgadriver)<0 then
   begin
   writeln('Internal Error');
   halt;
   end;
end.
