{$A-,B-,D+,E+,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X-,Y-}
unit ssb2;

interface
procedure run;
implementation

uses video13h,keyboard;
type Tscr=array[0..199,0..319] of byte;
     SegmentT = Array[0..65534] of byte;
     Virseg = ^SegmentT;

var
{scr:Tscr absolute $A000:0000;}
  buf:^Tscr;
  _lx,_ly,ilx,ily:array [1..3] of integer;
  i,j,nx,ny,nz,rx,ry,x,y,x1,y1,lx,ly:integer;
  tx,ty,tz:real;
  a,b:word;
  sbuf,obuf:word;


var fontseg,fontofs:integer;
 Segment : Virseg;
 litemap : word;

Procedure SetUpSegment(VAR segname:virseg;VAR add : word);
begin
GetMem (Segname,65534);
add := seg (Segname^);
end;

Procedure FillBox(x,y,w,h:integer; color:byte);
var i,j,k:integer;
begin
for i:=y to y+h-1 do
    for j:=x to x+w-1 do
        buf^[i,j]:=color;
end;

Procedure Print(x,y:integer; s:string; xs,ys:integer; color:byte);
var i,j,k,c,px,py:integer; b:byte;
begin
px:=x;py:=y;
for k:=1 to length(s) do
    begin
    c:=ord(s[k]);
    for i:=0 to 7 do
        begin
        b:=mem[fontseg:fontofs+(c-128)*8+i];
        for j:=0 to 7 do
            begin
            if b shl j and 128<>0 then FillBox(x,y,xs,ys,color);
            inc(x,xs);
            end;
        x:=px;
        inc(y,ys);
        end;
    y:=py; inc(px,xs*8); x:=px;
end;
end;

Procedure Blur;
var i,j,k:integer;
begin
for i:=0 to 199 do
    for j:=0 to 319 do
        buf^[i,j]:=(buf^[i-1,j]+buf^[i+1,j]+buf^[i,j-1]+buf^[i,j+1]) div 4;
end;

Procedure ASMBumpmapping;assembler;
asm
{few times faster ;) }
    push es
    mov ax,sbuf
    mov es,ax
    mov ax,obuf
    mov bx,320*3
    add ax,bx
    mov di,ax
    mov si,bx
    mov dx,199
    sub dx,5
@1: mov cx,320
@2: xor bh,bh; xor ah,ah;
    mov al, es:[di+1]
    mov bl, es:[di-1]
    sub ax,bx
    sub ax,320; add ax,cx; add ax,lx; add ax,128;
    cmp ax,255; jc @ok1; mov ax,255; @ok1:
    push ax
    xor ah,ah;
    mov al, es:[di+320]
    mov bl, es:[di-320]
    sub ax,bx
    sub ax,197; add ax,dx; add ax,ly; add ax,128;
    cmp ax,255; jc @ok2; mov ax,255; @ok2:
    pop bx
    mov bh,bl; mov bl,al
    push es
    mov ax, litemap
    mov es,ax
    and bx,0FFFEh
    mov bx,[es:bx]
    mov ax, 0A000h
    mov es,ax

    cmp bx,0
    jz  @nopix

    mov [es:si],bx
@nopix:

    pop es
    inc di
    inc si
    loop @2
    dec dx;
    jnz @1
    mov ax,$0a000
    mov es,ax
    xor ax,ax
    mov [es:si-1],ax
    pop es
end;{asm Bumpmaping}

procedure run;
var tim:longint;
label key;
begin
getmem(buf,65000);
sbuf:=seg(buf^);obuf:=ofs(buf^);

SetUpSegment(Segment,litemap);
for y:=0 to 255 do
    for x:=0 to 255 do
        begin
        tX:=(x-128)/64.0;
        tY:=(y-128)/64.0;
        tZ:=1-sqrt(tX*tX+tY*tY);
        if (tZ<0) then tZ:=0; mem[litemap:x+y*256]:=round(tz*254);
        end;

fillchar(buf^,65000,0);
for i:=0 to 10000 do fillbox(random(320),random(200),1,1,255);
blur;
print(40,30,'JAGUAR',5,5,155);
print(47,145,'presents',4,4,155);
blur;blur;blur;

ilx[1]:=5;ily[1]:=0;
_ly[1]:=40;_lx[1]:=60;

ilx[2]:=-5;ily[2]:=0;
_ly[2]:=160;_lx[2]:=260;

for a:=0 to 255 do setpal(a,0,0,0);

tim:=0;
repeat
if tim<255 then
    for a:=tim to 255 do setpal(a,tim div 4,tim div 4,0);

    inc(tim,4);
    for a:=1 to 2 do
        begin
        lx:=_lx[a];ly:=_ly[a];
        ASMBumpmapping;
        inc(_lx[a],ilx[a]);if (_lx[a]>260) or (_lx[a]<60) then ilx[a]:=-ilx[a];
        end;
    if tim>300 then
       for a:=tim-300 to 255 do setpal(a,(a-(tim-300)) div 4,(a-(tim-300)) div 4,0);

if _keypressed then goto key;
until tim>550;{ESC}
key:
freemem(buf,65000);
freescreen;
end;

begin
asm
   push es
   push bp
   mov ax,$1130
   mov bx,05h
   int 10h
   mov fontseg,es
   mov fontofs,bp
   pop bp
   pop es
end;
end.
